-- Debug - GUI

local scene = { }

function scene:load(opt)
  self.gui = gui()
  
  self.texts = { }
  
  --self.test_win = self.gui:newWindow({x = 24, y = 128, w = 960, h = 480})
  
  --self.test_text = text({text = {"This is a test testing all the ", colorTable("red_panda"), "test stuff ", colorTable("white"), "that needs to be tested to see if it works in a testing environment,", "/hold .5", " and,", "/hold .5", " therefore,", "/hold .5", " also in a ", colorTable("blue"), "/jump 2", "non-testing ", "/jump -1", colorTable("white"), "environment.", "/hold 1", "/shake true", " Look out!", "/shake false", "/hold 1", " Oh,", "/hold .5", " nevermind.", "/hold 1", " Thought I saw a monster."}, w = 480})
  
  --self.test_msg = message({"This is a test testing all the ", colorTable("red_panda"), "test stuff ", colorTable("white"), "that needs to be tested to see if it works in a testing environment,", "/hold .5", " and,", "/hold .5", " therefore,", "/hold .5", " also in a ", colorTable("blue"), "/jump 2", "non-testing ", "/jump -1", colorTable("white"), "environment.", "/hold 1", "/shake true", " Look out!", "/shake false", "/hold 1", " Oh,", "/hold .5", " nevermind.", "/hold 1", " Thought I saw a monster."}, {x = 24, y = 128, w = 640})
  
  --self.test_msg = message({"This is a ", "/jump 2", "real ", "/jump -1", "short one.", "/hold 1", "/hold -1"}, {x = 24, y = 128, w = 640})
  
  --self.test_msg = self.gui:newMessage({text = {"This is a ", "/jump 2", "real ", "/jump -1", "short one.", "/hold 1", "/hold -1"}, x = 24, y = 128, w = 640})
  
  --self.test_msg = self.gui:newMessage({queue = {{"This is a ", "/jump 2", "real ", "/jump -1", "short one.", "/hold 1", "/hold -1"}, {"This may be a few too many tables.", "/hold 1", " I guess time will tell.", "/hold 1", "/hold -1"}}, off_canvas = true, x = 24, y = 128, w = 448}):center()
  
  --self.test_text = text({text = "Need to test whether or not we can change text after the fact.", x = 256, y = 240, w = 480})
  
  self.test_msg = self.gui:newMessage({queue = {{text = {"Need to test whether or not we can change text after the fact.", "/hold -1"}}, {text = {"Hey, this is a", "/jump 2", " whole new text", "/jump -1", " here. It's a bit of a doozy, too. I'm gonna stretch this guy out into a real long piece of prose so that I can make sure it really understands what I mean when I say", colorTable("blue"), " \"instant\"", colorTable("white"), " you know?", "/hold -1"}}}, arrow = {up = true, down = true, right = true, left = true}, off_canvas = true, w = 480, instant = true}):center():open()
  
  --[[table.insert(self.texts, text({text = localize("testing_text", "pangram_num"), x = 4, y = 4}))
  table.insert(self.texts, text({text = localize("testing_text", "pangram_num"), x = 4, y = 36, font = fonts.compass}))
  table.insert(self.texts, text({text = localize("testing_text", "pangram_num"), x = 4, y = 68, font = fonts.equipment}))
  table.insert(self.texts, text({text = localize("testing_text", "pangram_num"), x = 4, y = 100, font = fonts.expression}))]]
  
  --[[local y = 4
  for k, f in pairs(fonts) do
    local nt = text({text = {colorTable("red_panda"), k, colorTable("white"), " " .. localize("testing_text", "pangram_num")}, x = 4, y = y, font = f})
    --local nt = text({text = {colorTable("red_panda"), k}, x = 4, y = y, font = f})
    y = y + nt:getHeight()
    table.insert(self.texts, nt)
  end]]
  
  self.tdial = dial({value = 0, spinners = 6, neutral_zeroes = true, currency_spinner = true})
  self.tdial2 = dial({value = math.random(1, 9999), spinners = 6, neutral_zeroes = true, mod_spinner = "pos_neg", currency_spinner = true})
  
  self.test_win = self.gui:newWindow({w = self.tdial:getWidth() + 24, h = 60}):center()
  self.test_win.arrow = {
    right = true,
    left = true
  }
  self.test_win.onUpdate = function(self)
    if self.top then
      if control:wasPressed("right") then
        scene.tdial:add(1, 0, 100)
      elseif control:wasPressed("left") then
        scene.tdial:add(-1, 0, 100)
      end
    end
  end
  self.test_win.canvasDraw = function(self)
    scene.tdial:draw()
  end
end

function scene:update(dt)
  self.gui:update(dt)
  
  for i, t in ipairs(self.texts) do
    t:update(dt)
  end
  
  --self.test_text:update(dt)
  
  if control:keyPressed('r') then
    settings.window.h = math.min(1, settings.window.h + .01)
  elseif control:keyPressed('f') then
    settings.window.h = math.max(0, settings.window.h - .01)
  end
  
  if control:keyPressed('t') then
    settings.window.s = math.min(1, settings.window.s + .01)
  elseif control:keyPressed('g') then
    settings.window.s = math.max(0, settings.window.s - .01)
  end
  
  if control:keyPressed('y') then
    settings.window.l = math.min(1, settings.window.l + .01)
  elseif control:keyPressed('h') then
    settings.window.l = math.max(0, settings.window.l - .01)
  end
  
  if control:keyPressed("space") then
    if self.test_win.state == "HIDDEN" then
      self.test_win.state = "OPEN"
    elseif self.test_win.state == "IDLE" then
      self.test_win.state = "CLOSE"
    end
  end
  
  if control:keyPressed('b') then
    self.tdial:add(-1)
  end
  
  if control:keyPressed('n') then
    --self.test_text.hold = 0
    
    self.tdial:add(1)
  end
  
  if control:keyPressed('m') then
    --self.test_text = text({text = {"Hey, this is a", "/jump 2", " whole new text", "/jump -1", " here. It's a bit of a doozy, too. I'm gonna stretch this guy out into a real long piece of prose so that I can make sure it really understands what I mean when I say", colorTable("blue"), " \"instant\"", colorTable("white"), " you know?"}, instant = true, x = 256, y = 240, w = 480})
    
    --self.tdial:set(21064)
    
    self.test_win.tx = self.test_win.tx + 180
  end
  
  if control:keyPressed('v') then
    if self.tdial2.value ~= 0 then
      self.tdial:add(self.tdial2.value, 0)
      self.tdial2.value = 0
    else
      if math.random() > .5 then
        self.tdial2.value = math.random(1, 999999)
      else
        self.tdial2.value = -math.random(1, 999999)
      end
    end
  end
  
  self.tdial:update(dt)
  self.tdial2:update(dt)
end

function scene:draw()
  setColor("white", .24)
  love.graphics.rectangle("fill", 0, 0, 1280, 720)
  setColor("white", 1)
  
  self.gui:draw()
  
  for i, t in ipairs(self.texts) do
    t:draw()
  end
  
  --self.tdial:draw(42, 64)
  --self.tdial2:draw(24, 24)
  
  --self.test_text:draw()
end

return scene