log("  ╠ QR Code...Code")

function createQRCode(data, ec_level, foreground, background)
  local ok, qrdata = qrencode.qrcode(data, ec_level)
  
  if ok then
    local qr = love.graphics.newCanvas(#qrdata + 6, #qrdata[1] + 6)
    local old_can = love.graphics.getCanvas()
    love.graphics.setCanvas(qr)
      if background then
        love.graphics.clear(getColor(background, 1))
      else
        love.graphics.clear(1, 1, 1, 1)
      end
      --love.graphics.rectangle("fill", 0, 0, #data + 6, #data[1] + 6)
      for c, rd in ipairs(qrdata) do
        for r, blk in ipairs(rd) do
          if blk > 0 then
            setColor(foreground or "black", 1)
            love.graphics.rectangle("fill", 3 + (c - 1), 3 + (r - 1), 1, 1)
          end
        end
      end
    love.graphics.setCanvas(old_can)
    return love.graphics.newImage(qr:newImageData())
  else
    err(qrdata)
    return love.graphics.newImage("gfx/system/palette.png")
  end
end