-- Screen resolutions and their maths

screen_res = {
  scale = function()
    return system_canvas:getHeight() / (screen_res[game_res].h * system_scale)
  end,
  x = function()
    return (system_canvas:getWidth() / 2) - (((screen_res[game_res].w * system_scale) * screen_res.scale()) / 2)
  end,
  
  nes = {
    w = 256,
    h = 240
  },
  
  psx_wide = {
    w = 384,
    h = 216
  },
  
  gba = {
    w = 240,
    h = 160
  },
  
  gba_mod = {
    w = 320,
    h = 180
  }
}