-- Date

local dur = {
  year = 31536000, --this is for 365; use 31557600 for 365.25
  day = 86400,
  hour = 3600,
  minute = 60
}

function timeToTable(time)
  local ret = {
    years = 0,
    days = 0,
    hours = 0,
    minutes = 0,
    seconds = 0
  }
  
  ret.years = math.floor(time / dur.year)
  ret.days = math.floor((time % dur.year) / dur.day)
  ret.hours = math.floor((time % dur.day) / dur.hour)
  ret.minutes = math.floor((time % dur.hour) / dur.minute)
  ret.seconds = time % dur.minute
  
  return ret
end