-- Font showcase

local scene = {
  --system_canvas = true
}

function scene:load(opt)
  self.texts = { }
  
  local y = 4
  for k, f in pairs(fonts) do
    --local nt = text({text = {colorTable("red_panda"), k, colorTable("white"), " " .. localize("testing_text", "pangram_num")}, x = 4, y = y, w = love.graphics.getWidth() - 8, font = f})
    local tt = table.append({colorTable("red_panda"), k, colorTable("white"), " "}, localize("testing_text", "pangram_fx"))
    local nt = text({text = tt, x = 4, y = y, w = canvasWidth() - 8, font = f})
    y = y + nt:getHeight() + 16
    table.insert(self.texts, nt)
  end
end

function scene:update(dt)
  for i, t in ipairs(self.texts) do
    t:update(dt)
  end
end

function scene:draw()
  setColor("white")
  love.graphics.rectangle("fill", 0, 0, love.graphics.getWidth(), love.graphics.getHeight())
  for i, t in ipairs(self.texts) do
    t:draw()
  end
end

return scene